diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index 2aefe2c52..4f0b272f8 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -2113,7 +2113,7 @@ public class World implements WorldSource {
         x += side.getOffsetX();
         y += side.getOffsetY();
         z += side.getOffsetZ();
-        if(getBlockId(x, y, z) == Blocks.FIRE.id())
+        if(getBlockId(x, y, z) == Blocks.FIRE.id() || getBlockId(x, y, z) == Blocks.FIRE_COLD.id())
         {
             playBlockEvent(entityplayer, LevelListener.EVENT_FIRE_EXTINGUISH, x, y, z, 0);
             setBlockWithNotify(x, y, z, 0);
@@ -2320,7 +2320,7 @@ public class World implements WorldSource {
             int maxLightingUpdates = 1000000;
             if(lightingToUpdate.size() > maxLightingUpdates)
             {
-                System.out.println("More than " + maxLightingUpdates + " updates, dropping first " + maxLightingUpdates / 2 + " lighting updates");
+                LOGGER.warn("More than " + maxLightingUpdates + " updates, dropping first " + maxLightingUpdates / 2 + " lighting updates");
                 lightingToUpdate.subList(0, maxLightingUpdates / 2).clear();
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/Biomes.java b/game/core/src/main/java/net/minecraft/core/world/biome/Biomes.java
index 109abd665..bf5205f60 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/Biomes.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/Biomes.java
@@ -2,34 +2,43 @@ package net.minecraft.core.world.biome;
 
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.world.biome.nether.*;
+import net.minecraft.core.world.biome.overworld.*;
+import net.minecraft.core.world.biome.paradise.BiomeParadise;
 import net.minecraft.core.world.weather.Weathers;
 
 public class Biomes
 {
 
-    public static final Biome OVERWORLD_RAINFOREST = register("minecraft:overworld.rainforest", new BiomeRainforest("rainforest").setColor(0x1cf100).setBlockedWeathers(Weathers.OVERWORLD_SNOW));
-    public static final Biome OVERWORLD_SWAMPLAND = register("minecraft:overworld.swampland", new BiomeSwamp("swampland").setColor(0x00ff78));
-    public static final Biome OVERWORLD_SEASONAL_FOREST = register("minecraft:overworld.seasonal_forest", new BiomeSeasonalForest("seasonal_forest").setColor(0x64ce15));
-    public static final Biome OVERWORLD_FOREST = register("minecraft:overworld.forest", new BiomeForest("forest").setColor(0x26a615));
-    public static final Biome OVERWORLD_GRASSLANDS = register("minecraft:overworld.grasslands", new Biome("grasslands").setColor(0xf0f048).setBlockedWeathers(Weathers.OVERWORLD_SNOW));
-    public static final Biome OVERWORLD_OUTBACK = register("minecraft:overworld.outback", new BiomeOutback("outback").setColor(0xd95e20).setBlockedWeathers(Weathers.OVERWORLD_SNOW).setTopBlock(Blocks.DIRT_SCORCHED.id()).setFillerBlock(Blocks.DIRT_SCORCHED.id()));
-    public static final Biome OVERWORLD_SHRUBLAND = register("minecraft:overworld.shrubland", new BiomeShrubland("shrubland").setColor(0xbaba38));
-    public static final Biome OVERWORLD_TAIGA = register("minecraft:overworld.taiga", new BiomeTaiga("taiga").setColor(0x8abcff).setSurfaceSnow());
-    public static final Biome OVERWORLD_BOREAL_FOREST = register("minecraft:overworld.boreal_forest", new BiomeBorealForest("boreal_forest").setColor(0x148564));
-    public static final Biome OVERWORLD_DESERT = register("minecraft:overworld.desert", new BiomeDesert("desert").setColor(0xEDE26F).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM).setTopBlock(Blocks.SAND.id()).setFillerBlock(Blocks.SAND.id()));
-    public static final Biome OVERWORLD_PLAINS = register("minecraft:overworld.plains", new BiomePlains("plains").setColor(0xA3C649));
-    public static final Biome OVERWORLD_GLACIER = register("minecraft:overworld.glacier", new Biome("glacier").setColor(0xcbf6ff).setSurfaceSnow().setTopBlock(Blocks.BLOCK_SNOW.id()).setFillerBlock(Blocks.BLOCK_SNOW.id()));
-    public static final Biome OVERWORLD_TUNDRA = register("minecraft:overworld.tundra", new Biome("tundra").setColor(0x57e0ff).setSurfaceSnow());
-    public static final Biome OVERWORLD_MEADOW = register("minecraft:overworld.meadow", new BiomeBorealForest("meadow").setColor(0x8c8c22));
-    public static final Biome NETHER_NETHER = register("minecraft:nether.nether", new BiomeNether("nether").setColor(0xDD0000).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG));
-    public static final Biome PARADISE_PARADISE = register("minecraft:paradise.paradise", new BiomeParadise("paradise").setColor(0x8080FF).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG));
-    public static final Biome OVERWORLD_BIRCH_FOREST = register("minecraft:overworld.birch_forest", new BiomeBirchForest("birch_forest").setColor(0x4bcb5e));
-    public static final Biome OVERWORLD_RETRO = register("minecraft:overworld.retro", new BiomeRetro("retro").setColor(0x76B14A).setTopBlock(Blocks.GRASS.id()));
-    public static final Biome OVERWORLD_HELL = register("minecraft:overworld.hell", new Biome("hell").setColor(0xD96223).setTopBlock(Blocks.DIRT_SCORCHED.id()).setTopBlock(Blocks.DIRT_SCORCHED.id()));
-    public static final Biome OVERWORLD_SWAMPLAND_MUDDY = register("minecraft:overworld.swampland.muddy", new BiomeSwamp("swampland.muddy").setColor(0x522700));
-    public static final Biome OVERWORLD_OUTBACK_GRASSY = register("minecraft:overworld.outback.grassy", new BiomeOutback("outback.grassy").setColor(0xf09037).setBlockedWeathers(Weathers.OVERWORLD_SNOW).setTopBlock(Blocks.GRASS_SCORCHED.id()).setFillerBlock(Blocks.DIRT_SCORCHED.id()));
-    public static final Biome OVERWORLD_CAATINGA = register("minecraft:overworld.caatinga", new BiomeCaatinga("caatinga").setColor(0xdecda6).setTopBlock(Blocks.MUD_BAKED.id()).setFillerBlock(Blocks.MUD_BAKED.id()).setBlockedWeathers(Weathers.OVERWORLD_SNOW));
-    public static final Biome OVERWORLD_CAATINGA_PLAINS = register("minecraft:overworld.caatinga.plains", new Biome("caatinga.plains").setColor(0xa19477).setTopBlock(Blocks.MUD_BAKED.id()).setFillerBlock(Blocks.MUD_BAKED.id()).setBlockedWeathers(Weathers.OVERWORLD_SNOW));
+    public static final Biome OVERWORLD_RAINFOREST = register("minecraft:overworld.rainforest", new BiomeRainforest("overworld.rainforest").setColor(0x1cf100).setBlockedWeathers(Weathers.OVERWORLD_SNOW));
+    public static final Biome OVERWORLD_SWAMPLAND = register("minecraft:overworld.swampland", new BiomeSwamp("overworld.swampland").setColor(0x00ff78));
+    public static final Biome OVERWORLD_SEASONAL_FOREST = register("minecraft:overworld.seasonal_forest", new BiomeSeasonalForest("overworld.seasonal_forest").setColor(0x64ce15));
+    public static final Biome OVERWORLD_FOREST = register("minecraft:overworld.forest", new BiomeForest("overworld.forest").setColor(0x26a615));
+    public static final Biome OVERWORLD_GRASSLANDS = register("minecraft:overworld.grasslands", new Biome("overworld.grasslands").setColor(0xf0f048).setBlockedWeathers(Weathers.OVERWORLD_SNOW));
+    public static final Biome OVERWORLD_OUTBACK = register("minecraft:overworld.outback", new BiomeOutback("overworld.outback").setColor(0xd95e20).setBlockedWeathers(Weathers.OVERWORLD_SNOW).setTopBlock(Blocks.DIRT_SCORCHED.id()).setFillerBlock(Blocks.DIRT_SCORCHED.id()));
+    public static final Biome OVERWORLD_SHRUBLAND = register("minecraft:overworld.shrubland", new BiomeShrubland("overworld.shrubland").setColor(0xbaba38));
+    public static final Biome OVERWORLD_TAIGA = register("minecraft:overworld.taiga", new BiomeTaiga("overworld.taiga").setColor(0x8abcff).setSurfaceSnow());
+    public static final Biome OVERWORLD_BOREAL_FOREST = register("minecraft:overworld.boreal_forest", new BiomeBorealForest("overworld.boreal_forest").setColor(0x148564));
+    public static final Biome OVERWORLD_DESERT = register("minecraft:overworld.desert", new BiomeDesert("overworld.desert").setColor(0xEDE26F).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM).setTopBlock(Blocks.SAND.id()).setFillerBlock(Blocks.SAND.id()));
+    public static final Biome OVERWORLD_PLAINS = register("minecraft:overworld.plains", new BiomePlains("overworld.plains").setColor(0xA3C649));
+    public static final Biome OVERWORLD_GLACIER = register("minecraft:overworld.glacier", new Biome("overworld.glacier").setColor(0xcbf6ff).setSurfaceSnow().setTopBlock(Blocks.BLOCK_SNOW.id()).setFillerBlock(Blocks.BLOCK_SNOW.id()));
+    public static final Biome OVERWORLD_TUNDRA = register("minecraft:overworld.tundra", new Biome("overworld.tundra").setColor(0x57e0ff).setSurfaceSnow());
+    public static final Biome OVERWORLD_MEADOW = register("minecraft:overworld.meadow", new BiomeBorealForest("overworld.meadow").setColor(0x8c8c22));
+    public static final Biome PARADISE_PARADISE = register("minecraft:paradise.paradise", new BiomeParadise("overworld.paradise").setColor(0x8080FF).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG));
+    public static final Biome OVERWORLD_BIRCH_FOREST = register("minecraft:overworld.birch_forest", new BiomeBirchForest("overworld.birch_forest").setColor(0x4bcb5e));
+    public static final Biome OVERWORLD_RETRO = register("minecraft:overworld.retro", new BiomeRetro("overworld.retro").setColor(0x76B14A).setTopBlock(Blocks.GRASS_RETRO.id()));
+    public static final Biome OVERWORLD_HELL = register("minecraft:overworld.hell", new Biome("overworld.hell").setColor(0xD96223).setTopBlock(Blocks.DIRT_SCORCHED.id()).setTopBlock(Blocks.DIRT_SCORCHED.id()));
+    public static final Biome OVERWORLD_SWAMPLAND_MUDDY = register("minecraft:overworld.swampland.muddy", new BiomeSwamp("overworld.swampland.muddy").setColor(0x522700));
+    public static final Biome OVERWORLD_OUTBACK_GRASSY = register("minecraft:overworld.outback.grassy", new BiomeOutback("overworld.outback.grassy").setColor(0xf09037).setBlockedWeathers(Weathers.OVERWORLD_SNOW).setTopBlock(Blocks.GRASS_SCORCHED.id()).setFillerBlock(Blocks.DIRT_SCORCHED.id()));
+    public static final Biome OVERWORLD_CAATINGA = register("minecraft:overworld.caatinga", new BiomeCaatinga("overworld.caatinga").setColor(0xdecda6).setTopBlock(Blocks.MUD_BAKED.id()).setFillerBlock(Blocks.MUD_BAKED.id()).setBlockedWeathers(Weathers.OVERWORLD_SNOW));
+    public static final Biome OVERWORLD_CAATINGA_PLAINS = register("minecraft:overworld.caatinga.plains", new Biome("overworld.caatinga.plains").setColor(0xa19477).setTopBlock(Blocks.MUD_BAKED.id()).setFillerBlock(Blocks.MUD_BAKED.id()).setBlockedWeathers(Weathers.OVERWORLD_SNOW));
+    public static final Biome NETHER_NETHER = register("minecraft:nether.nether", new BiomeNether("nether.nether").setColor(0xDD0000).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG).setTopBlock(Blocks.COBBLE_NETHERRACK.id()).setFillerBlock(Blocks.COBBLE_NETHERRACK.id()));
+    public static final Biome NETHER_VOLCANIC_ISLANDS = register("minecraft:nether.volcanic_islands", new BiomeVolcanoIslands("nether.volcanic_islands").setColor(0xDD0000).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG).setTopBlock(Blocks.COBBLE_NETHERRACK.id()).setFillerBlock(Blocks.COBBLE_NETHERRACK.id()));
+    public static final Biome NETHER_SULFUR_POOLS = register("minecraft:nether.sulfur_pools", new BiomeSulfurPools("nether.sulfur_pools").setColor(0xDD0000).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG).setTopBlock(Blocks.COBBLE_NETHERRACK.id()).setFillerBlock(Blocks.COBBLE_NETHERRACK.id()));
+    public static final Biome NETHER_CRYSTAL_FOREST = register("minecraft:nether.crystal_forest", new BiomeCrystalForest("nether.crystal_forest").setColor(0xDD0000).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG).setTopBlock(Blocks.COBBLE_NETHERRACK.id()).setFillerBlock(Blocks.COBBLE_NETHERRACK.id()));
+    public static final Biome NETHER_ASH_PLAINS = register("minecraft:nether.ash_plains", new BiomeAshPlains("nether.ash_plains").setColor(0xDD0000).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG).setTopBlock(Blocks.SLATE.id()).setFillerBlock(Blocks.SLATE.id()));
+    public static final Biome NETHER_BONEYARD = register("minecraft:nether.boneyard", new BiomeBoneyard("nether.boneyard").setColor(0xDD0000).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG).setTopBlock(Blocks.SOULSAND.id()).setFillerBlock(Blocks.SOULSAND.id()));
+
     public static Biome register(String key, Biome biome)
     {
         Registries.BIOMES.register(key, biome);
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/nether/BiomeAshPlains.java b/game/core/src/main/java/net/minecraft/core/world/biome/nether/BiomeAshPlains.java
new file mode 100644
index 000000000..e2dd96b1e
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/nether/BiomeAshPlains.java
@@ -0,0 +1,22 @@
+package net.minecraft.core.world.biome.nether;
+
+import net.minecraft.core.entity.SpawnListEntry;
+import net.minecraft.core.entity.monster.MobGhast;
+import net.minecraft.core.entity.monster.MobZombiePig;
+import net.minecraft.core.world.biome.Biome;
+
+public class BiomeAshPlains
+    extends Biome
+{
+
+    public BiomeAshPlains(String key) {
+        super(key);
+        spawnableMonsterList.clear();
+        spawnableCreatureList.clear();
+        spawnableWaterCreatureList.clear();
+        spawnableAmbientCreatureList.clear();
+        spawnableMonsterList.add(new SpawnListEntry(MobGhast.class, 10));
+        spawnableMonsterList.add(new SpawnListEntry(MobZombiePig.class, 10));
+
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/nether/BiomeBoneyard.java b/game/core/src/main/java/net/minecraft/core/world/biome/nether/BiomeBoneyard.java
new file mode 100644
index 000000000..715278b4f
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/nether/BiomeBoneyard.java
@@ -0,0 +1,20 @@
+package net.minecraft.core.world.biome.nether;
+
+import net.minecraft.core.entity.SpawnListEntry;
+import net.minecraft.core.entity.monster.MobGhast;
+import net.minecraft.core.entity.monster.MobZombiePig;
+import net.minecraft.core.world.biome.Biome;
+
+public class BiomeBoneyard extends Biome {
+
+    public BiomeBoneyard(String key) {
+        super(key);
+        spawnableMonsterList.clear();
+        spawnableCreatureList.clear();
+        spawnableWaterCreatureList.clear();
+        spawnableAmbientCreatureList.clear();
+        spawnableMonsterList.add(new SpawnListEntry(MobGhast.class, 10));
+        spawnableMonsterList.add(new SpawnListEntry(MobZombiePig.class, 10));
+
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/nether/BiomeCrystalForest.java b/game/core/src/main/java/net/minecraft/core/world/biome/nether/BiomeCrystalForest.java
new file mode 100644
index 000000000..382ef99c7
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/nether/BiomeCrystalForest.java
@@ -0,0 +1,20 @@
+package net.minecraft.core.world.biome.nether;
+
+import net.minecraft.core.entity.SpawnListEntry;
+import net.minecraft.core.entity.monster.MobGhast;
+import net.minecraft.core.entity.monster.MobZombiePig;
+import net.minecraft.core.world.biome.Biome;
+
+public class BiomeCrystalForest
+    extends Biome {
+    public BiomeCrystalForest(String key) {
+        super(key);
+        spawnableMonsterList.clear();
+        spawnableCreatureList.clear();
+        spawnableWaterCreatureList.clear();
+        spawnableAmbientCreatureList.clear();
+        spawnableMonsterList.add(new SpawnListEntry(MobGhast.class, 10));
+        spawnableMonsterList.add(new SpawnListEntry(MobZombiePig.class, 10));
+
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeNether.java b/game/core/src/main/java/net/minecraft/core/world/biome/nether/BiomeNether.java
similarity index 86%
rename from game/core/src/main/java/net/minecraft/core/world/biome/BiomeNether.java
rename to game/core/src/main/java/net/minecraft/core/world/biome/nether/BiomeNether.java
index cc6b7496a..ef76fe354 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/nether/BiomeNether.java
@@ -1,8 +1,9 @@
-package net.minecraft.core.world.biome;
+package net.minecraft.core.world.biome.nether;
 
 import net.minecraft.core.entity.monster.MobGhast;
 import net.minecraft.core.entity.monster.MobZombiePig;
 import net.minecraft.core.entity.SpawnListEntry;
+import net.minecraft.core.world.biome.Biome;
 
 public class BiomeNether extends Biome
 {
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/nether/BiomeSulfurPools.java b/game/core/src/main/java/net/minecraft/core/world/biome/nether/BiomeSulfurPools.java
new file mode 100644
index 000000000..9ac8ded6e
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/nether/BiomeSulfurPools.java
@@ -0,0 +1,19 @@
+package net.minecraft.core.world.biome.nether;
+
+import net.minecraft.core.entity.SpawnListEntry;
+import net.minecraft.core.entity.monster.MobGhast;
+import net.minecraft.core.entity.monster.MobZombiePig;
+import net.minecraft.core.world.biome.Biome;
+
+public class BiomeSulfurPools
+extends Biome {
+    public BiomeSulfurPools(String key) {
+        super(key);
+        spawnableMonsterList.clear();
+        spawnableCreatureList.clear();
+        spawnableWaterCreatureList.clear();
+        spawnableAmbientCreatureList.clear();
+        spawnableMonsterList.add(new SpawnListEntry(MobGhast.class, 10));
+        spawnableMonsterList.add(new SpawnListEntry(MobZombiePig.class, 10));
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/nether/BiomeVolcanoIslands.java b/game/core/src/main/java/net/minecraft/core/world/biome/nether/BiomeVolcanoIslands.java
new file mode 100644
index 000000000..246774fab
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/nether/BiomeVolcanoIslands.java
@@ -0,0 +1,19 @@
+package net.minecraft.core.world.biome.nether;
+
+import net.minecraft.core.entity.SpawnListEntry;
+import net.minecraft.core.entity.monster.MobGhast;
+import net.minecraft.core.entity.monster.MobZombiePig;
+import net.minecraft.core.world.biome.Biome;
+
+public class BiomeVolcanoIslands
+    extends Biome {
+    public BiomeVolcanoIslands(String key) {
+        super(key);
+        spawnableMonsterList.clear();
+        spawnableCreatureList.clear();
+        spawnableWaterCreatureList.clear();
+        spawnableAmbientCreatureList.clear();
+        spawnableMonsterList.add(new SpawnListEntry(MobGhast.class, 10));
+        spawnableMonsterList.add(new SpawnListEntry(MobZombiePig.class, 10));
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeBirchForest.java b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeBirchForest.java
similarity index 90%
rename from game/core/src/main/java/net/minecraft/core/world/biome/BiomeBirchForest.java
rename to game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeBirchForest.java
index a69354919..13acfed9c 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeBirchForest.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeBirchForest.java
@@ -1,8 +1,9 @@
-package net.minecraft.core.world.biome;
+package net.minecraft.core.world.biome.overworld;
 
 import net.minecraft.core.entity.animal.MobWolf;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.SpawnListEntry;
+import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeTall;
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeBorealForest.java b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeBorealForest.java
similarity index 87%
rename from game/core/src/main/java/net/minecraft/core/world/biome/BiomeBorealForest.java
rename to game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeBorealForest.java
index 48e72e0ad..a26de87fb 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeBorealForest.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeBorealForest.java
@@ -1,8 +1,9 @@
-package net.minecraft.core.world.biome;
+package net.minecraft.core.world.biome.overworld;
 
 import net.minecraft.core.entity.animal.MobWolf;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.SpawnListEntry;
+import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeTaigaBushy;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeCaatinga.java b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeCaatinga.java
similarity index 89%
rename from game/core/src/main/java/net/minecraft/core/world/biome/BiomeCaatinga.java
rename to game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeCaatinga.java
index 033c563fa..793dba71d 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeCaatinga.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeCaatinga.java
@@ -2,9 +2,10 @@
 // Jad home page: http://www.kpdus.com/jad.html
 // Decompiler options: packimports(3) braces deadcode
 
-package net.minecraft.core.world.biome;
+package net.minecraft.core.world.biome.overworld;
 
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.generate.feature.tree.*;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeDesert.java b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeDesert.java
similarity index 84%
rename from game/core/src/main/java/net/minecraft/core/world/biome/BiomeDesert.java
rename to game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeDesert.java
index b371b04ed..63df9e873 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeDesert.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeDesert.java
@@ -1,8 +1,9 @@
-package net.minecraft.core.world.biome;
+package net.minecraft.core.world.biome.overworld;
 
 import java.util.Random;
 
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreePalm;
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeForest.java b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeForest.java
similarity index 92%
rename from game/core/src/main/java/net/minecraft/core/world/biome/BiomeForest.java
rename to game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeForest.java
index 969bf77f6..458603e3e 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeForest.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeForest.java
@@ -1,8 +1,9 @@
-package net.minecraft.core.world.biome;
+package net.minecraft.core.world.biome.overworld;
 
 import net.minecraft.core.entity.animal.MobWolf;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.SpawnListEntry;
+import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeFancy;
 import net.minecraft.core.world.generate.feature.WorldFeature;
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeOutback.java b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeOutback.java
similarity index 89%
rename from game/core/src/main/java/net/minecraft/core/world/biome/BiomeOutback.java
rename to game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeOutback.java
index cbb17769a..956cc2e29 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeOutback.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeOutback.java
@@ -1,8 +1,9 @@
-package net.minecraft.core.world.biome;
+package net.minecraft.core.world.biome.overworld;
 
 import net.minecraft.core.entity.monster.MobSpider;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.SpawnListEntry;
+import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeEucalyptus;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/BiomePlains.java b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomePlains.java
similarity index 84%
rename from game/core/src/main/java/net/minecraft/core/world/biome/BiomePlains.java
rename to game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomePlains.java
index 0d858c304..5bcc35fee 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/BiomePlains.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomePlains.java
@@ -1,6 +1,7 @@
-package net.minecraft.core.world.biome;
+package net.minecraft.core.world.biome.overworld;
 
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeEucalyptus;
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeRainforest.java b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeRainforest.java
similarity index 94%
rename from game/core/src/main/java/net/minecraft/core/world/biome/BiomeRainforest.java
rename to game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeRainforest.java
index 713a64d42..10944c5c0 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeRainforest.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeRainforest.java
@@ -1,8 +1,9 @@
-package net.minecraft.core.world.biome;
+package net.minecraft.core.world.biome.overworld;
 
 import java.util.Random;
 
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeFancyRainforest;
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeRetro.java b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeRetro.java
similarity index 92%
rename from game/core/src/main/java/net/minecraft/core/world/biome/BiomeRetro.java
rename to game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeRetro.java
index 217afe5fb..16284c0e2 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeRetro.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeRetro.java
@@ -1,9 +1,10 @@
-package net.minecraft.core.world.biome;
+package net.minecraft.core.world.biome.overworld;
 
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.SpawnListEntry;
 import net.minecraft.core.entity.animal.*;
 import net.minecraft.core.entity.monster.*;
+import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeFancy;
@@ -13,7 +14,7 @@ import java.util.Random;
 public class BiomeRetro
     extends Biome
 {
-    protected BiomeRetro(String key)
+    public BiomeRetro(String key)
     {
     	super(key);
         spawnableMonsterList.clear();
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeSeasonalForest.java b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeSeasonalForest.java
similarity index 93%
rename from game/core/src/main/java/net/minecraft/core/world/biome/BiomeSeasonalForest.java
rename to game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeSeasonalForest.java
index 04fae0399..a7dedb093 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeSeasonalForest.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeSeasonalForest.java
@@ -1,8 +1,9 @@
-package net.minecraft.core.world.biome;
+package net.minecraft.core.world.biome.overworld;
 
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.SpawnListEntry;
 import net.minecraft.core.entity.animal.MobWolf;
+import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeCherry;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeFancy;
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeShrubland.java b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeShrubland.java
similarity index 83%
rename from game/core/src/main/java/net/minecraft/core/world/biome/BiomeShrubland.java
rename to game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeShrubland.java
index 8d07d2ea1..8ed06dd22 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeShrubland.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeShrubland.java
@@ -1,6 +1,7 @@
-package net.minecraft.core.world.biome;
+package net.minecraft.core.world.biome.overworld;
 
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeShrub;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 
